{***************************************************************************
 Beispielprogramm fuer ComboBox im DBGrid.


 Copyright 2009, Prof. Dr. T.I. Kesztyues
 This code is published under the GPL
***************************************************************************}

unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  ZConnection, ZDataset, db, DBGrids, DbCtrls, Grids, FileCtrl, Buttons,
  StdCtrls, ZSqlUpdate, ZSqlMonitor;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Edit1: TEdit;
    Label1: TLabel;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    ZQuery2: TZQuery;
    ZUpdateSQL1: TZUpdateSQL;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1CloseUp(Sender: TObject);
    procedure DBGrid1ColExit(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FormShow(Sender: TObject);
    procedure ZQuery1AfterPost(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 
  v_buffer:string;

implementation

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
     ZQuery2.SQL.Clear;
     ZQuery2.SQL.Add('select * from language');
     ZQuery2.Open;
     while not ZQuery2.EOF do
     begin
        ComboBox1.Items.AddObject(ZQuery2.FieldByName('languageName').asString,TObject(ZQuery2.FieldByName('language_id').AsInteger));
        ZQuery2.Next;
     end; { of while }
     ZUpdateSQL1.ModifySQL.Add('update person set name_last=:name_last,name_first=:name_first,language_id=:language_id where pid=:pid;');
     ZUpdateSQL1.DeleteSQL.Add('delete from person where pid=:pid;');
     ZUpdateSQL1.InsertSQL.Add('insert into person (name_last,name_first,language_id) values (:name_last,:name_first,:language_id);');
end;

procedure TForm1.ZQuery1AfterPost(DataSet: TDataSet);
begin
  ZQuery1.Refresh;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
   ZQuery1.Locate('name_last',Edit1.Text,[loPartialKey,loCaseInsensitive]);
end;

procedure TForm1.ComboBox1CloseUp(Sender: TObject);
begin
  if DataSource1.State in [dsEdit, dsInsert] then
  begin
     if ComboBox1.ItemIndex>=0 then
     begin
        ZQuery1.FieldByName('language_id').AsString:=inttostr(integer(ComboBox1.Items.Objects[ComboBox1.ItemIndex]));
     end;
  end;
end;

procedure TForm1.DBGrid1ColExit(Sender: TObject);
var v_index:Integer;
begin
   if (DBGrid1.SelectedColumn.FieldName='languageName') then
   begin
      ComboBox1.Visible:=False;
   end; { of if }
end;

procedure TForm1.DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
   if (State = [gdFixed]) then
   begin
      DBGrid1.Canvas.Font.Color:=clBlack;
      DBGrid1.Canvas.Brush.Color:=clBtnFace;
      DBGrid1.canvas.FillRect(Rect);
      with DBGrid1.Canvas do
      begin
         Pen.Style := psSolid;
         Pen.Width := 1;
         Pen.Color := clWhite;
         Polyline([point(rect.left, rect.bottom),
               rect.TopLeft, point(rect.Right, rect.top)]);
         Pen.Color := clBtnShadow;
         Polyline([point(rect.left+1, rect.bottom-1),
               point(rect.right-1, rect.bottom-1),
               point(rect.Right-1, rect.Top+1)]);
       end;
      DBGrid1.DefaultDrawColumnCell(Rect, DataCol, Column, State);
   end;
   if not (State = [gdFixed]) then
   begin
      DBGrid1.Canvas.Font.Color:=clBlack;
      DBGrid1.Canvas.Brush.Color:=clWhite;
      DBGrid1.canvas.FillRect(Rect);
      with DBGrid1.Canvas do
      begin
         Pen.Style := psSolid;
         Pen.Width := 1;
         Pen.Color := clWhite;
         Polyline([point(rect.left, rect.bottom),
               rect.TopLeft, point(rect.Right, rect.top)]);
         Pen.Color := clBtnShadow;
         Polyline([point(rect.left+1, rect.bottom-1),
               point(rect.right-1, rect.bottom-1),
               point(rect.Right-1, rect.Top+1)]);
       end;
      DBGrid1.DefaultDrawColumnCell(Rect, DataCol, Column, State);
   end;
  if (gdFocused in State) and (DataSource1.State in [dsEdit, dsInsert]) then
  begin
    if (Column.Field.FieldName = 'languageName') then
    with ComboBox1 do
    begin
      Left := Rect.Left + DBGrid1.Left;
      Top := Rect.Top + DBGrid1.Top;
      Width := Rect.Right - Rect.Left-1;
      Height := Rect.Bottom - Rect.Top;
      Visible := True;
      ComboBox1.ItemIndex:=Combobox1.Items.IndexOfObject(TObject(ZQuery1.FieldByName('language_id').AsInteger));
    end;
  end;
end;

initialization
  {$I unit1.lrs}

end.

